// gps_SDL
//xsetaseta@gmail.com
//12/09/2012

// ver 0.1


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"
#include <unistd.h>

#define YesWindows 1


#if YesWindows 
 #include <windows.h>
 #define BAURATEW CBR_38400
#else
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <termios.h>
 #define BAUDRATE B38400

#endif

#define DEBUG 0
#define SONIDO 0


Uint32 TimeLeft(void);
int Inirs232();
SDL_Surface *load_image( char *filename );
void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination );
void apply_surfaceB( int x, int y, SDL_Surface* source, SDL_Surface* destination,SDL_Rect* clip );
int init();
int load_files();

void Paintbutton(int x,int y,int w,int h,char *texto,unsigned char tipo);
void PaintBoton(int numero,int modo);
void PaintBotones();
int DetecBotones(int x, int y);
void Inibotones();

void PaintLight(int x,int y,int w,int h,char *texto,unsigned char tipo,int clase);
void PaintLuz(int numero,int modo);
void PaintLuces();
void IniLuces();

#if YesWindows  
int WriteSerie(HANDLE hSerial,char *c,int tamano);
int ReadSerie(HANDLE hSerial,char *c,int tamano);
#endif

void Inientradas();
void PaintInput(int x,int y,int w,int h,char *texto,unsigned char tipo);
void PaintEntrada(int numero,int modo);
void PaintEntradas();
void TextEntrada(int numero,char *s);


void PaintText(int x,int y,int w,int h,char *texto,unsigned char tipo,int clase);
void PaintTex(int numero,int modo);
void PaintTextos();

void ProcesoEntradas();
//void ClearOut();


	const int SCREEN_WIDTH = 640; 
	const int SCREEN_HEIGHT = 480; 
	const int SCREEN_BPP = 32;

	//The surfaces that will be used 
	SDL_Surface *message = NULL; 
	SDL_Surface *background = NULL; 
	SDL_Surface *screen = NULL;
	SDL_Surface *dots = NULL;

	SDL_Event event;

	TTF_Font *font = NULL;

	SDL_Color textColor = { 25, 25, 25 };

	char VARI[100];


#if YesWindows 
	char MODEMDEVICEdefault[]= "COM4";
	HANDLE hSerial;
// DCB dcbSerial;
    DCB dcbSerialParams;
    COMMTIMEOUTS time_out;
#else
	char MODEMDEVICEdefault[]= "/dev/ttyUSB0";
	struct termios newtermios;
	int fd;
#endif

char *MODEMDEVICE;

char Binput[100];
char Binput2[10];
int  ContadorI;
char *CEntrada;

Mix_Chunk *sonido;

int TICK_INTERVAL=5000;
unsigned char almacen;


struct DATOSGPS{
	char cadena[16];
};
struct DATOSGPS datosgps[22];

FILE *ficheroGPS;
time_t fecha;
struct tm *tiempofecha; 

#include "compo.c"
#include "grafi.c"

//_________________________________________________

void split (char separador)
{
 int x,xx,y,z;
	z=sizeof(VARI);
	y=0; 
	xx=0;
	for(x=0;x<z;x++)
	 {
		datosgps[y].cadena[xx]=VARI[x];
		if(VARI[x]==0) break;
		if( separador==VARI[x]) 
		 {
			 datosgps[y].cadena[xx]=0;
			 xx=0;
			 y++;
		 }
		 else
		 {
			 xx++;
		 }
	 }
}

void insert(int n,char caracter)
{
 int x;
	x=sizeof(VARI);
	for(;x>n;x--)
	{
		VARI[x]=VARI[x-1];
	}
	VARI[x]=caracter;
}

Uint32 TimeLeft(void)
{
    static Uint32 next_time = 0;
    Uint32 now;

    now = SDL_GetTicks();
    if ( next_time <= now ) {
        next_time = now+TICK_INTERVAL;
        return(0);
    }
    return(next_time-now);
}

int Inirs232()
{
#if YesWindows  	
 //____________Programacion serie Windows__________________________
 
 
         hSerial = CreateFile(MODEMDEVICE,GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING,0, NULL);

         if(hSerial==INVALID_HANDLE_VALUE)
           {
             if(GetLastError()==ERROR_FILE_NOT_FOUND)
              {
               printf("PUERTO NO EXISTE !! \n"); 
               return 0;
              }
           }
           else
           {
//            dcbSerial.DCBlength=sizeof(dcbSerialParams);
            if (!GetCommState(hSerial, &dcbSerialParams))
               {
                printf("Error get Status!!\n");
                return 0;
               }                           
            dcbSerialParams.BaudRate=BAURATEW;
            dcbSerialParams.ByteSize=8;
            dcbSerialParams.StopBits=ONESTOPBIT;
            dcbSerialParams.Parity=NOPARITY;
            if (!SetCommState (hSerial, &dcbSerialParams))
              {
               CloseHandle(hSerial);
               printf("Error get Status2!!\n");
               return 0;
              }           
            time_out.ReadIntervalTimeout = 20; 
            time_out.ReadTotalTimeoutMultiplier = 2; 
            time_out.ReadTotalTimeoutConstant = 50; 
            time_out.WriteTotalTimeoutMultiplier = 2; 
            time_out.WriteTotalTimeoutConstant = 50;  
            if (SetCommTimeouts(hSerial, &time_out)==0)
               printf("Error SetCommTimeouts \n"); 
           }
#else
//_________Programacion Linux________________________

	
	fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NDELAY );
   	if (fd <0) 
		{
		 printf("Error puerto de comunicaciones\n");
		 exit(-1);  
		}	
  newtermios.c_cflag= BAUDRATE | CS8 | CLOCAL | CREAD;
  newtermios.c_iflag=IGNPAR;
  newtermios.c_oflag=0;
  newtermios.c_lflag=0;
  newtermios.c_cc[VMIN]=1;
  newtermios.c_cc[VTIME]=0;

  cfsetospeed(&newtermios,BAUDRATE);
  cfsetispeed(&newtermios,BAUDRATE);
 
  if (tcflush(fd,TCIFLUSH)==-1) return -1;
  if (tcflush(fd,TCOFLUSH)==-1) return -1;
  if (tcsetattr(fd,TCSANOW,&newtermios)==-1) return -1;  

  //Hace que el puerto serie no espere	
  fcntl(fd, F_SETFL, O_NDELAY );	
#endif

	return 0;
}

SDL_Surface *load_image( char *filename )
{ 
	SDL_Surface *temp,*ima;

	temp  =IMG_Load(filename);
	if (temp == NULL){
		printf("Error al cargar %s\n", filename);
		exit(EXIT_FAILURE);
	}			 
		ima = SDL_DisplayFormat(temp);
		SDL_FreeSurface( temp );

        if( ima != NULL )
        {
            Uint32 colorkey = SDL_MapRGB( ima->format, 0, 0xFF, 0xFF );
            SDL_SetColorKey( ima, SDL_SRCCOLORKEY, colorkey );
			if(DEBUG)printf("ok al cargar %s\n", filename);
        }
	
	return ima; 
}



void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, NULL, destination, &offset );
	}
void apply_surfaceB( int x, int y, SDL_Surface* source, SDL_Surface* destination,SDL_Rect* clip )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, clip, destination, &offset );
	}

int init()
{
    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )  return 0;
 //   screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
    screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );

    if( screen == NULL )   return 0;
	
    if(TTF_Init()==-1) 
		{
    	 printf("TTF_Init: %s\n", TTF_GetError());
   		 return 0;
		}
	//Initialize SDL_mixer 
	if(SONIDO)if( Mix_OpenAudio( 22050, MIX_DEFAULT_FORMAT, 2, 4096 ) == -1 )
		{
		 printf("Error SDL Mixer_Init:");
		 return 0;
		}

    SDL_WM_SetCaption( "Monitor de GPS", NULL );

    if((ficheroGPS=fopen("gpsreg.txt","aw"))==NULL)
        {
		 printf("****Error registro salida****\n");
		}
#if YesWindows    
    freopen ("CON", "w", stdout );
    freopen ("CON", "w", stderr );
#endif
		
    fecha = time( NULL );
    tiempofecha = gmtime(&fecha );
    fprintf(ficheroGPS,"\nFECHA %s\n",asctime(tiempofecha));

    return 1;
}

int load_files()
{
    background = load_image( "gpssdl2.jpg" );
    if( background == NULL )  return 0;
	dots = load_image( "gpssdl1.png" );
    if( dots == NULL )  return 0;

    font = TTF_OpenFont( "seta.ttf", 20 );
	if( font == NULL )
    {
		printf("Error cargando Font\n");
        return 0;
    }
	// Cargamos sonido
	if(SONIDO)sonido = Mix_LoadWAV("pit.wav");
 	if(SONIDO)if ( sonido == NULL )
		{
		 printf("No pude cargar sonido: %s\n", Mix_GetError());
     	 exit(1);
 		}
  return 1;
}


void clean_up()
{
	if(SONIDO)Mix_FreeChunk(sonido);
    SDL_FreeSurface( background );
	SDL_FreeSurface( dots );
    SDL_Quit();
}


#if YesWindows  
int WriteSerie(HANDLE hSerial,char *c,int tamano)
{
 int bRes;
 DWORD dwError, dwNumBytesWritten=0;
              bRes=WriteFile(hSerial,c,tamano,&dwNumBytesWritten,NULL );
              if (!bRes) printf("Error mandado Bytes %u   \n",dwNumBytesWritten);	    
}


int ReadSerie(HANDLE hSerial,char *c,int tamano)
{
 int bRes;
 DWORD dwError, bytesRead=0;
              bRes=ReadFile(hSerial,c,tamano,&bytesRead,NULL );
              if (!bRes)
              {
                printf("Error leyendo Bytes %u \n",bytesRead);	
                return -1;
              }
              if(bytesRead==0) return -2;                               
}

#endif
 



void ProcesoEntradas()
{
	if(!strncmp(VARI,"$GPGGA",5)) 
		{			
			split(',');
			if(DEBUG)printf(">%s<\n",VARI);
			VARI[42]=0;
			TextEntrada(0,VARI);
			TextEntrada(6,VARI+43); //+43


			strcpy(VARI,datosgps[1].cadena);
			insert(2,':');
			insert(5,':');
			VARI[8]=0;
            if(almacen!=0)fprintf(ficheroGPS,"%s  ",VARI);

			TextEntrada(1,VARI);
			TextEntrada(2,datosgps[9].cadena);
			TextEntrada(3,datosgps[2].cadena);
			TextEntrada(4,datosgps[4].cadena);
			TextEntrada(5,datosgps[7].cadena);
			sprintf(VARI,"%s'%s %s'%s",datosgps[2].cadena,datosgps[3].cadena,datosgps[4].cadena,datosgps[5].cadena);

			insert(2,' ');
			insert(16,' ');			
			
			TextEntrada(7,VARI);
			if(almacen!=0)
              {
               fprintf(ficheroGPS,"%s\n",VARI);
               almacen=0;
   			   printf("%s\n",VARI);
               }

			if(datosgps[6].cadena[0]!='0')
				{
					nluz[0].estado=1;
				}
				else
				{
					nluz[0].estado=0;
				}
			PaintLuces();	
			goto salirpro;
		}
 salirpro:
	PaintLuces();
	SDL_Flip( screen );
}	


void RepintarPantalla()
{
	apply_surface( 0, 0, background, screen );
    message = TTF_RenderText_Solid( font, "SDL-GPS", textColor );
	apply_surface( 270, 1, message, screen );
	PaintBotones();
	PaintLuces();
	PaintEntradas ();
	PaintTextos();
	TextEntrada(8,MODEMDEVICE);
	SDL_Flip( screen );
}

int main(int argc, char *argv[])
{
  
 	int mouse_x,mouse_y;
	int zboton=0;	
    int quit = 0;
    Uint8 *teclas; 
	int nbytes;
	int canal;
    
#if YesWindows 
	freopen("CON", "w", stdout); // redirects stdout
	freopen("CON", "w", stderr); // redirects stderr
#endif

    printf("%s\n",argv[0]);
	if(argc==2)
		{
		 printf("%s\n",argv[1]);
 	 	 MODEMDEVICE=argv[1];
		}
	 else
		{
		 MODEMDEVICE=MODEMDEVICEdefault;
		}
	printf("Monitorizar GPS ");

	printf(MODEMDEVICE);
	printf("\n");
	Inirs232();


	Inibotones();
	IniLuces ();
	Inientradas();
	Initextos();

    if( init() == 0 ) return 1;
    if( load_files() == 0 ) return 2;	
	RepintarPantalla();	
    if( SDL_Flip( screen ) == -1 ) return 3;
//    SDL_Delay(100);
#if YesWindows 
    printf("MODO WINDOWS\n");
    PurgeComm(hSerial,PURGE_RXCLEAR | PURGE_TXCLEAR);//Vacia buffer 
    SDL_Delay(1500);
#else
    printf("MODO LINUX\n");
	while(( nbytes = read(fd, Binput2, 1)>0 )); //Vacia buffer
#endif

	canal = Mix_PlayChannel(-1, sonido, 0);

    ContadorI=0;
    almacen=1;
	
    while( quit == 0 )
    {	
		SDL_Delay(100);
#if YesWindows
         while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
		 while(( nbytes = read(fd, Binput2, 1)>0 ))
#endif		
		{
		 //printf("Leer %d -> %s\n",nbytes,Binput2);	
		 Binput[ContadorI]=Binput2[0];
		 ContadorI++;
	  	 if (Binput2[0] == '\n')
           {
			if(ContadorI<2)ContadorI=2;   
          	Binput[ContadorI-2]=0;
		  	ContadorI=0;	
  			//if(DEBUG)printf("Leidos-> %s\n",Binput);
			sprintf(VARI,"%s",Binput);
			ProcesoEntradas();
       	   } 
		}
     	if(!TimeLeft())
	                {
	                //printf("time\n");				
	                almacen=1;
                    }
        while( SDL_PollEvent( &event ) )
        {
			teclas = SDL_GetKeyState(NULL);
			if(teclas[SDLK_ESCAPE] ) quit = 1;
            if( event.type == SDL_QUIT )   quit = 1;
            if( event.type == SDL_KEYDOWN ) 
			{
				if(DEBUG)printf("Evento Tecla\n");
				if(event.key.keysym.sym == SDLK_f)
                    {  
          #if YesWindows
                     screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
          #else
                     SDL_WM_ToggleFullScreen(screen);
          #endif  
                     RepintarPantalla();
                    }
				if(event.key.keysym.sym == SDLK_m)
				 {
					screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );
					RepintarPantalla();
				 }
			}
			if( event.type == SDL_MOUSEBUTTONDOWN ) {
				mouse_x=event.button.x;
				mouse_y=event.button.y;
				zboton=DetecBotones(mouse_x,mouse_y);
				if(zboton!=-1)
					{                            
                 	 switch (zboton)
                        {                         
                         case 0:
							goto salir;                        
                         break;                                                        													
                        default:                         
                     	printf("%s\n",VARI);					
                        }                               
					 PaintBoton(zboton,1);
					}

					if(DEBUG)printf("Evento Raton X=%d Y=%d Boton=%d\n",mouse_x,mouse_y,zboton);					
					if( SDL_Flip( screen ) == -1 ) return 3;
			}
			if( event.type == SDL_MOUSEBUTTONUP ) {
				if(zboton!=-1){
					PaintBotones();
					PaintLuces();
					if(DEBUG)printf("RepintarBoton %d\n",zboton);
					zboton=-1;					
				}					
				if( SDL_Flip( screen ) == -1 ) return 3;
			}
	
        }
    }
 
salir: 
     //Free the surface and quit SDL
    clean_up();
#if YesWindows    
    CloseHandle(hSerial);
#else    
	close(fd);
#endif
      fclose(ficheroGPS);
    return 0;
   
}
 
